#ifndef BACKUP_RASPI_H
#define BACKUP_RASPI_H
#include <QDialog>
#include <QProcess>
#include <QProgressDialog>
#include <QThread>
#include <QDebug>
#include "mainwindow.h"
namespace Ui {
class Backup_raspi;
}

class Backup_raspi : public QDialog
{
    Q_OBJECT

public:
    explicit Backup_raspi(QWidget *parent = 0);
    ~Backup_raspi();
    void loadList();
    void listMedia();

private slots:
     void on_pushB_Refresh_clicked();
     void on_buttonBox_CancelOkBackup_accepted();
private:
    Ui::Backup_raspi *ui;
    void ui_thread();
    QProgressDialog *progress_dialog;
    QProcess myProcess;
};


class QThreadBackup : public QThread
{
public:
    void run() {

        QProcess *processBackup = new QProcess();

         processBackup->start("sh " LIBEXECDIR "/script %s");
         processBackup->waitForStarted();
         processBackup->waitForFinished(-1);

    }
};
#endif // BACKUP_RASPI_H
