#ifndef DCLAVIER_H
#define DCLAVIER_H

#include <QDialog>
#include "utils.h"
#include <QTreeWidgetItem>

namespace Ui {
class DClavier;
}

class DClavier : public QDialog
{
    Q_OBJECT

public:
    explicit DClavier(QWidget *parent = 0);
    ~DClavier();
    void populate_kbd_tree(QPushButton *btn);
private slots:
    void on_buttonBox_accepted();

private:
    Ui::DClavier *ui;
    vector<vector<string> > layouts;
    vector<vector<string> > variants;
    vector<vector<string> > get_layout();
    vector<vector<string> > get_variant(string layout);

signals:
    void signalUpdateBtn(QString kbd);
};

#endif // DCLAVIER_H
