#include "dformatusb.h"
#include "ui_dformatusb.h"
#include <stdio.h>
#include <QtDBus/QDBusAbstractInterface>
#include<fstab.h>
#include <QTimer>
#include <QtDBus/QtDBus>
#include "utils.h"
#include <QDialog>
#include <QPushButton>
#define DEVICEFILE "/proc/scsi/sg/device_strs"
#ifndef __arm__
#define HOME "/tmp/listMedia"
#define MEDIAINFO "/tmp/infoStorage"
#else
#define HOME "/tmp/listMedia"
#define MEDIAINFO "/tmp/infoStorage"
#endif
#include <QMessageBox>
#include <QThread>
#include <QProgressDialog>
#include <QString>
#include <QGridLayout>
#include <QGroupBox>
#include <QRadioButton>
#include <QSpinBox>
#include <QSettings>

DformatUSB::DformatUSB(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DformatUSB)
{
    ui->setupUi(this);
    listMedia();
}

void DformatUSB::listMedia(){
    qDebug()<<"//////////////////Debut initiate Backup_raspi///////////////////////";

    ui->comboBox->clear();
    QProcess process;
    QProcess procRecup_info;

    procRecup_info.setStandardOutputFile(MEDIAINFO);
    process.setStandardOutputFile(HOME);
    process.start("sh", QStringList() << "-c" << "lsblk -l -o KNAME,VENDOR,MODEL,SIZE | grep sd | grep -v mmc");
    process.waitForFinished();

    QFile file(HOME);
    QString retour = NULL;
    QStringList lstAppend;
    if(file.open(QFile::ReadOnly|QFile::Text))
    {
        QString line;
        QTextStream in(&file);
        do{

            line = in.readLine();
            //qDebug()<<line;
            QStringList lstRes = line.split(" ", QString::SkipEmptyParts);
            //qDebug()<<"Longueur de lstRes: " << lstRes.length();
            for(int i=0; i<lstRes.length(); i++){
             //   qDebug()<<"\nIteration n°:" << i;

        //           qDebug()<<"\nRecuperation part :" << i;
                    retour = lstRes.at(i);
                    QStringList recupPartition = retour.split("/dev/", QString::SkipEmptyParts);
              //      qDebug()<< "\nrecupPartition:" <<recupPartition;
                    lstAppend.append(recupPartition.at(0));

            }
        }while(!in.atEnd());
    }
    file.close();
     QStringList finalShow;

//    qDebug()<<"listFinale" << lstAppend;


    for(int i=0; i<lstAppend.length(); i++){
        QString correctList = lstAppend.at(i).mid(0, 3);
        procRecup_info.start("sh", QStringList() << "-c" << " lsblk -o KNAME,VENDOR,MODEL,SIZE |grep " +correctList);
        procRecup_info.waitForFinished();

        QFile fileInfo(MEDIAINFO);
        QStringList lstResInfo;

        if(fileInfo.open(QFile::ReadOnly)){
            QString lineInfo;
            QTextStream info(&fileInfo);
            do{
                lineInfo = info.readLine();
//                qDebug()<<"LineInfo" << lineInfo;
                lstResInfo = lineInfo.split(" ", QString::SkipEmptyParts);
//                qDebug()<<"lstResInfo: " << lstResInfo;
//                qDebug()<<"Longueur lstResInfo:" << lstResInfo.length();
                if(!(lstResInfo.length()<5)){
                    finalShow.append(lstResInfo.at(1) + " " + lstResInfo.at(2)
                                 + " " + lstResInfo.at(3) + " (" + lstResInfo.at(4) + ") " + "|" + "(" + lstResInfo.at(0) + ")");
                }

            }while(!info.atEnd());
        }
        fileInfo.close();
        for(int i=0; i<finalShow.length();i++){
            for(int j=0; j<finalShow.length();j++){
                if(i!=j){
                    if(finalShow.at(i)==finalShow.at(j)){
//                        qDebug()<<"La ligne " << i << "est identique a la ligne" << j;
                        finalShow.removeAt(j);
                    }
                }
            }
        }
//        qDebug()<<"Dernier finalShow:"<<finalShow;

    }
qDebug()<<"////////////////Fin initiate//////////////////////";
    for(int i=0; i<finalShow.length(); i++){
         ui->comboBox->addItem(finalShow.at(i));
    }
}




void DformatUSB::on_pushB_Refresh_clicked(){
    DformatUSB::listMedia();


}

void DformatUSB::on_buttonBox_CancelOkUSB_accepted(){
    qDebug()<<"//////////////Processing device cleaning/////////////";
    QMessageBox::StandardButton format_dialog;
    format_dialog = QMessageBox::information(this, " ", "Are you sure you want to erase that media?", QMessageBox::Yes|QMessageBox::No);
    if(format_dialog == QMessageBox::Yes) {


    //    QProcess process;
        QProcess processUnmount;
        QProcess processMkfs;
        QProcess processErase;
        QProcess processPartprobe;
        QProcess processCreate;


       // QProcess processElevator;
        progress_dialog = new QProgressDialog();
        //connect(&process,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(reset()));
       connect(&processUnmount,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(reset()));
       connect(&processPartprobe,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
        connect(&processMkfs,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
        connect(&processErase,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
         connect(&processCreate,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
        //connect(&process,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(close()));
        //connect(progress_dialog,SIGNAL(canceled()),this,SLOT(installCancelled()));


        qDebug()<<"\n/////////////Getting the line///////////////";
        if(!ui->comboBox->currentText().isEmpty()){
            QStringList lstLineComboBox=ui->comboBox->currentText().split("|").last().split("(", QString::SkipEmptyParts).last().split(")",QString::SkipEmptyParts);
            qDebug()<<"Ligne recuperee:"<<lstLineComboBox;

            QString retour = lstLineComboBox.at(0);
            QString tmp = "/dev/"+retour;
            retour=tmp;



            //process.setStandardOutputFile(HOME);
            //process.start("sh", QStringList() << "-c" << "lsblk -l -o KNAME,VENDOR,MODEL,SIZE | grep sd | grep -v mmc");

            //process.waitForFinished();


                    //TODO: Decomment the following 4lines to activate this function.
            QProcess partition;
            partition.start("sh", QStringList() << "-c" << "lsblk " + retour + " | grep -v disk | grep -v NAME | wc -l" );
            partition.waitForFinished();

            QString output = partition.readAllStandardOutput();
            qDebug()<<"Read output:" << output;
            QString nbPartition = output.left(1);
            int k = nbPartition.toInt();
            QString listNum[10]={"1","2","3","4","5","6","7","8","9"};
            qDebug()<<"Number of partitions :"<< k;

            qDebug()<<"Suppressing all partition in the device";
            QTimer *timer = new QTimer(this);
            connect(timer, SIGNAL(timeout()),this, SLOT(update()));
                    for (int j=0; j<k ;j++){

                        qDebug()<<"Check error:";
                        processPartprobe.start("sh", QStringList() << "-c" << " sudo partprobe " + retour);
                        ui_thread();
                        processPartprobe.waitForFinished();

                        timer->start(5);
                        qDebug()<<"Partition: "<<listNum[j];
                        qDebug()<<"echo -e 'd\n" + listNum[j] +"' | sudo fdisk " + retour;

                        qDebug()<< "Trying to erase...";
                        processErase.start("sh", QStringList() << "-c" << " sudo echo -e 'd\n" + listNum[j] + "\nw' | sudo fdisk " + retour);
                        ui_thread();
                        processErase.waitForFinished();
                       timer->start(5);
                        qDebug()<< "Device erased.";

                        timer->start(5);
                        qDebug()<<"Trying to umount...";
                        processUnmount.start("sh", QStringList() << "-c" << " umount " + retour + listNum[j]);
                        ui_thread();
                        processUnmount.waitForFinished();
                        qDebug()<< "Media Unmounted";
                }




                    timer->start(5);
                    qDebug()<<"Create first partition "<<endl;
                    processCreate.start("sh", QStringList() << "-c" << " sudo echo -e 'n\np\n1\n \n \nw' | sudo fdisk " + retour);
                    ui_thread();
                    processCreate.waitForFinished();

                    timer->start(5);
                    qDebug()<<"Format the partition in Fat32";
                    processMkfs.start("sh", QStringList() << "-c" << " sudo mkfs.fat -F 32 -I " +retour+"1");
                    ui_thread();
                    processMkfs.waitForFinished();


        }else{
            QMessageBox::StandardButton format_dialogEmpty;
            format_dialogEmpty = QMessageBox::information(this, " ", "ERROR:You didn't select any media.", QMessageBox::Cancel);
        }
        QMessageBox::StandardButton format_dialogEmpty;

        format_dialogEmpty = QMessageBox::information(this, " ", "Device correctly cleaned !", QMessageBox::Ok);
        qDebug()<<"Device correctly cleaned \n////////////////////////////";
    }
    if(format_dialog == QMessageBox::No) {
        DformatUSB *d = new DformatUSB();
        d->exec();
    }
}
void
DformatUSB::ui_thread ()
{
    progress_dialog->setWindowTitle("Applying configuration");
    progress_dialog->setLabelText("Please wait while executing the request...");
    progress_dialog->setRange(0,0);
    progress_dialog->exec();
}



DformatUSB::~DformatUSB()
{
    delete ui;
}
