#ifndef DPROXY_H
#define DPROXY_H
#include <QMap>
#include <QVariant>
#include <QString>

#include <QDialog>

namespace Ui {
class Dproxy;
}

class Dproxy : public QDialog
{
    Q_OBJECT

public:
    explicit Dproxy(QWidget *parent = 0);
    ~Dproxy();
    //Global var to keep the radio button chosen and maintain it when opening the
    //proxy window again
    static int recup_mode;
    //Global var to keep the hostname if modified
    static QString recup_host;
    static QString recup_type;
    static QString recup_passwd;
    static QString recup_user;
    static QString recup_proxy;

private slots:


    void disableItem(bool a);

    void ableItem(bool a);

    void accept(void);


    void on_proxyNone_clicked();

    void on_proxyAuto_clicked();

    void on_proxyManu_clicked();

private:
    Ui::Dproxy *ui;
    QMap<QString, QVariant> m_map;
};

#endif // DPROXY_H
