#ifndef NATPROXY_H
#define NATPROXY_H

#include <QNetworkProxy>
#include <QNetworkProxyFactory>
#include <QUrl>
//#include <pxProxyFactory.h>
#include "dproxy.h"
#include <proxy.h>


class NatProxy : public QNetworkProxyFactory
{

public:
    NatProxy(int type, QString host, QString user, QString pwd);
    ~NatProxy();

    QList<QNetworkProxy> queryProxy(const QNetworkProxyQuery &query = QNetworkProxyQuery());

private:
    int proxyType;
    pxProxyFactory *pf;
    QString proxyUser;
    QString proxyPwd;
    QUrl proxyUri;

};

#endif // NATPROXY_H
