#ifndef APPCONFIG_H
#define APPCONFIG_H

#include <QCheckBox>
#include "utils.h"
#include <QLabel>

class AppConfig
{
public:
    static std::string read_locale();
    void writeConfig(bool tzChanged);
    static void get_autostart(QCheckBox *chkBox);
    static void set_autostart(QCheckBox *chkBox, bool autostartChanged);
    void get_root_device(QLabel *lbl);
    string read_tz();
    void set_wifi_blue(bool, bool);

    AppConfig();
    QString locale_value;
    QString kdb;
    QString init_kdb_value;
    QString tz;
    QString persistent;
    int hour;
    int min;

    QString lockMode;

};

#endif // APPCONFIG_H
