#ifndef DFORMATUSB_H
#define DFORMATUSB_H

#include <QDialog>
#include <QProgressDialog>
#include <QProcess>
#include <QPointer>

namespace Ui {
class DformatUSB;
}

class DformatUSB : public QDialog
{
    Q_OBJECT

public:
    explicit DformatUSB(QWidget *parent = 0);
    ~DformatUSB();

    void loadList();
    void listMedia();
signals:
    void progressValue (const int);

private slots:
     void on_pushB_Refresh_clicked();
     void on_buttonBox_CancelOkUSB_accepted();

private:
    Ui::DformatUSB *ui;
    void ui_thread();
    QProgressDialog *progress_dialog;
    QProcess processErase;
    QProcess myProcess;
    QProcess processUnmount;
    QProcess processMkfs;
    QProcess processPartprobe;

};

#endif // DFORMATUSB_H
