#ifndef DLOCK_SETUP_H
#define DLOCK_SETUP_H

#include <QDialog>

typedef struct _LockItems {
     bool no_kbd_shortcut;
     bool autolog;
     bool no_action;
     bool  no_menu;
     bool  no_icons_menu;
     bool  no_desktop;
     bool  no_open_save;
     bool  lconfeditor_icon;
     bool no_automount;
} LockItems;

namespace Ui {
class DLock_setup;
}

class DLock_setup : public QDialog
{
    Q_OBJECT

public:
    explicit DLock_setup(QWidget *parent = 0);
    ~DLock_setup();
    void read_config (LockItems *items);
    void save_config (LockItems *items);
    void apply_lock_settings();

    void set_defaults(LockItems *items);

private slots:


    void on_buttonBox_accepted();



private:
    Ui::DLock_setup *ui;
};

#endif // DLOCK_SETUP_H
