#ifndef DSHAREWINDOWS_H
#define DSHAREWINDOWS_H

#include <QDialog>

namespace Ui {
class DshareWindows;
}

typedef struct _mount{
    QString host;
    QString dir;
    QString mpoint;
    QString user;
    QString passwd;
}mount;

enum {
    S_TYPE_HOST = 0,
    S_TYPE_DIR,
    S_TYPE_MPOINT,
    S_TYPE_USER,
    S_TYPE_PASSWD
};


class DshareWindows : public QDialog
{
    Q_OBJECT

public:
    explicit DshareWindows(QWidget *parent = 0);
    ~DshareWindows();
   void mount_free();
   void get_mount_from_form ();
   void mount_save();
   _mount m;
   void mount_read();

void Suppr();

private slots:
   void on_pushB_add_clicked();




   void on_pushButton_2_clicked();

   void on_pushB_valid_clicked();

   void on_pushButton_clicked();

private:
    Ui::DshareWindows *ui;
};

#endif // DSHAREWINDOWS_H
