#-------------------------------------------------
#
# Project created by QtCreator 2015-04-13T14:17:37
#
#-------------------------------------------------

QT       += core gui
QT       += network
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

INCLUDEPATH += ../qjson4

TARGET = lconfeditor
TEMPLATE = app



SOURCES += \
    ../qjson4/QJsonArray.cpp \
    ../qjson4/QJsonDocument.cpp \
    ../qjson4/QJsonObject.cpp \
    ../qjson4/QJsonParseError.cpp \
    ../qjson4/QJsonParser.cpp \
    ../qjson4/QJsonValue.cpp \
    ../qjson4/QJsonValueRef.cpp \
    main.cpp\
    mainwindow.cpp \
    dialog.cpp \
    utils.cpp \
    dlanguage.cpp \
    appconfig.cpp \
    dclavier.cpp \
    dlock.cpp \
    dlock_setup.cpp \
    ltop_os_info.cpp \
    ltoplogin.cpp \
    pwd.cpp \
    dsharewindows.cpp \
    dproxy.cpp \
    dformatusb.cpp \
    screenconfig.cpp \
    includes/locales.cpp \
    forceresolution.cpp \
    reboot_sched.cpp \
    vnc.cpp


HEADERS += \
    ../qjson4/QJsonArray.h \
    ../qjson4/QJsonDocument.h \
    ../qjson4/QJsonObject.h \
    ../qjson4/QJsonParseError.h \
    ../qjson4/QJsonParser.h \
    ../qjson4/QJsonValue.h \
    ../qjson4/QJsonValueRef.h \
    mainwindow.h \
    dialog.h \
    utils.h \
    dlanguage.h \
    appconfig.h \
    dclavier.h \
    ltop_os_info.h \
    dlock.h \
    dlock_setup.h \
    pwd.h \
    ltoplogin.h \
    ../qjson4/QJsonRoot.h \
    dsharewindows.h \
    dproxy.h \
    dformatusb.h \
    screenconfig.h \
    forceresolution.h \
    reboot_sched.h \
    vnc.h

TRANSLATIONS += \
    ../translations/lconfeditor.en \
    ../translations/lconfeditor.fr

FORMS += \
    mainwindow.ui \
    dialog.ui \
    dlanguage.ui \
    dclavier.ui \
    dlock.ui \
    dlock_setup.ui \
    dsharewindows.ui \
    dproxy.ui \
    dformatusb.ui \
    screenconfig.ui \
    forceresolution.ui \
    pwd.ui \
    vnc.ui

OTHER_FILES += \
    dialog.ui.orig \
    ltools-ng.pro.user \
    passwd.txt \
    passwd.ini \
    CMakeLists.txt
