#include "pwd.h"
#include "ui_pwd.h"
#include "utils.h"
#include <QSettings>
#include <QMessageBox>
#include "vnc.h"

pwd::pwd(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::pwd)
{
    ui->setupUi(this);


    //masque le mot de passe
    ui->lineEdit->setEchoMode(QLineEdit::Password);
    ui->lineEdit_2->setEchoMode(QLineEdit::Password);

    ui->pushB_Ok->setEnabled(false);
}

pwd::~pwd()
{
    delete ui;
}

void pwd::on_pushB_Cancel_clicked()
{
    reject();
}


void pwd::on_pushB_Ok_clicked()
{
    if(ui->lineEdit->text() == ui->lineEdit_2->text() && ui->lineEdit->text() != "")
    {
        passwd = ui->lineEdit->text();
        accept();
    }
}

QString pwd::get_passwd()
{
    return passwd;
}


void pwd::on_lineEdit_2_textChanged(const QString &arg1)
{
    ui->pushB_Ok->setEnabled(arg1 == ui->lineEdit->text() && arg1 != "");
}

void pwd::on_lineEdit_textChanged(const QString &arg1)
{
    ui->pushB_Ok->setEnabled(arg1 == ui->lineEdit_2->text() && arg1 != "");
}
