#ifndef SCREENCONFIG_H
#define SCREENCONFIG_H

#include "ui_screenconfig.h"
#include <QDialog>
#include <QIcon>
#define PICONFFILE "/boot/config.txt"
#define SAVECONF "/boot/config.save"

namespace Ui {
class ScreenConfig;
}

class ScreenConfig : public QDialog
{
    Q_OBJECT

public:
    explicit ScreenConfig(QWidget *parent = 0);
    ~ScreenConfig();
    QString choosed_res;

private slots:
    void on_buttonBox_accepted();
    
    void on_buttonBox_rejected();

    void on_PB_adv_overscan_clicked();

    void on_CBRes_currentIndexChanged(int index);

private:
    Ui::ScreenConfig *ui;
    void readConfig();
};

#endif // SCREENCONFIG_H
